/*
 * Copyright (c) 2007 NTT DATA Corporation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package jp.terasoluna.thin.tutorial.web;


import java.io.IOException;

import javax.servlet.Filter;
import javax.servlet.FilterChain;
import javax.servlet.FilterConfig;
import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

/**
 * リクエストパラメータのエンコーディング設定を行う。
 * <p/>
 * ServletAPIバージョン2.3以上において有効。<br>
 * 下記のようにweb.xmlに設定する。
 * <p/>
 * &nbsp;&nbsp;&lt;filter&gt;<br>
 * &nbsp;&nbsp;&nbsp;
 * &lt;filter-name&gt;encodingFilter&lt;/filter-name&gt;<br>
 * &nbsp;&nbsp;&nbsp;&nbsp;&lt;filter-class&gt;<br>
 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
 * jp.terasoluna.sample.web.SetCharacterEncodingFilter<br>
 * &nbsp;&nbsp;&nbsp;&nbsp;&lt;/filter-class&gt;<br>
 * &nbsp;&nbsp;&nbsp;&nbsp;&lt;init-param&gt;<br>
 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
 * &lt;param-name&gt;encoding&lt;/param-name&gt;<br>
 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
 * &lt;param-value&gt;Windows-31J&lt;/param-value&gt;<br>
 * &nbsp;&nbsp;&nbsp;&nbsp;&lt;/init-param&gt;<br>
 * &nbsp;&nbsp;&lt;/filter&gt;<br>
 * &nbsp;&nbsp;&lt;filter-mapping&gt;<br>
 * &nbsp;&nbsp;&nbsp;
 * &lt;filter-name&gt;encodingFilter&lt;/filter-name&gt;<br>
 * &nbsp;&nbsp;&nbsp;&nbsp;&lt;url-pattern&gt;/*&lt;/url-pattern&gt;<br>
 * &nbsp;&nbsp;&lt;/filter-mapping&gt;<br>
 * <p/>
 *
 */
public class SetCharacterEncodingFilter implements Filter {

    /**
     * ログクラス
     */
    private static Log log =
        LogFactory.getLog(SetCharacterEncodingFilter.class);

    /**
     * エンコーディング。
     */
    protected String encoding = null;

    /**
     * フィルターコンフィグ。
     */
    protected FilterConfig filterConfig = null;

    /**
     * クライアントで指定されたエンコーディングを無視するかどうかのフラグ。
     */
    protected boolean ignore = true;

    /**
     * 終了時処理。
     */
    public void destroy() {
        this.encoding = null;
        this.filterConfig = null;

    }

    /**
     * フィルター処理。
     * リクエストパラメータを指定されたエンコーディングに設定する。
     *
     * @param request リクエスト
     * @param response レスポンス
     * @param chain フィルターチェーン
     * @exception IOException IO例外
     * @exception ServletException 例外
     */
    public void doFilter(ServletRequest request, ServletResponse response,
        FilterChain chain) throws IOException, ServletException {

        if (log.isDebugEnabled()) {
            log.debug("doFilter() called");
        }

        if (ignore || (request.getCharacterEncoding() == null)) {
            String encoding = selectEncoding(request);
            if (encoding != null) {
                request.setCharacterEncoding(encoding);
            }
        }
        chain.doFilter(request, response);
    }


    /**
     * 初期化処理。
     *
     * @param filterConfig フィルター設定
     * @exception ServletException 例外
     */
    public void init(FilterConfig filterConfig) throws ServletException {

        if (log.isDebugEnabled()) {
            log.debug("init() called.");
        }

        this.filterConfig = filterConfig;
        this.encoding = filterConfig.getInitParameter("encoding");
        if (log.isDebugEnabled()) {
            log.debug("this.encoding = " + this.encoding);
        }

        String value = filterConfig.getInitParameter("ignore");
        if (value == null) {
            this.ignore = true;
        } else if ("true".equalsIgnoreCase(value)) {
            this.ignore = true;
        } else if ("yes".equalsIgnoreCase(value)) {
            this.ignore = true;
        } else {
            this.ignore = false;
        }
    }

    /**
     * エンコーディング選択。
     *
     * @param request リクエスト
     * @return エンコーディング
     */
    protected String selectEncoding(ServletRequest request) {
        return this.encoding;
    }

}
